#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>

double **alloc_double_double(int size1,int size2) {

   double **tmp=NULL;
   register int i;

   tmp=(double **)calloc(size1,sizeof(double *));
   if (!tmp)   { printf("tmp calloc failed!\n"); exit(1); }

   tmp[0]=(double *)calloc(size1*size2,sizeof(double));
   if (tmp[0]==0) { printf("bit calloc failed!\n"); exit(1); }

   /* set up vector pointers */
   for (i=1; i<size1; i++) tmp[i]=tmp[0]+(size2 * i);

   return (tmp);
}
char **alloc_char_char(int size1,int size2) {

   char **tmp=NULL;
   register int i;

   tmp=(char **)calloc(size1,sizeof(char *));
   if (!tmp)   { printf("tmp calloc failed!\n"); exit(1); }

   tmp[0]=(char *)calloc(size1*size2,sizeof(char));
   if (tmp[0]==0) { printf("bit calloc failed!\n"); exit(1); }

   /* set up vector pointers */
   for (i=1; i<size1; i++)  tmp[i]=tmp[0]+(size2 * i);

   return (tmp);
}

char *alloc_char(int size1) {

   char *tmp=NULL;
   tmp=(char *)calloc(size1,sizeof(char));
   if (!tmp)   { printf("tmp calloc failed!\n"); exit(1); }
   return (tmp);
}

int *alloc_int(int size1) {

   int *tmp=NULL;
   tmp=(int *)calloc(size1,sizeof(int));
   if (!tmp)   { printf("tmp calloc failed!\n"); exit(1); }
   return (tmp);
}

double *alloc_double(int size1) {

   double *tmp=NULL;
   tmp=(double *)calloc(size1,sizeof(double));
   if (!tmp)   { printf("tmp calloc failed!\n"); exit(1); }
   return (tmp);
}

double ***alloc_double_double_double(int num_niche,int pop_size,int size) {

   double ***tmp=NULL;
   register int i,j;

   tmp      =(double ***)calloc(num_niche,sizeof(double **));
   tmp[0]   =(double **) calloc(num_niche*pop_size,sizeof(double *));
   tmp[0][0]=(double *)  calloc(num_niche*pop_size*size,sizeof(double));

   for (i=1; i<num_niche; i++) tmp[i]=tmp[0]+i*pop_size;

   for (j=1; j<pop_size; j++) tmp[0][j]=tmp[0][0]+size*j;

   for (i=1; i<num_niche; i++) {
      tmp[i][0]=tmp[0][0]+size*pop_size*i;
      for (j=1; j<pop_size; j++)  tmp[i][j]=tmp[i][0]+size*j;
   }
   return (tmp);
}
